<?php

/* public */ class plugin_config extends plugin {

  /* public void */ function _default(/* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($ARGS, "array");
    $event = strtolower($event);

    global $YANA;
    if (!empty($ARGS['id'])) $YANA->setVar("ID",$ARGS['id']);

      switch ($event) {

        case "index":
                 $YANA->language->read("admin");
                 $dir           = $YANA->plugins->getPluginDir();
                 $PLUGINFILES   = $YANA->plugins->getPluginList();
                 $PROFILES      = $YANA->registry->files['PROFILEDIR']->getContent();
                 $YANA->setVar("LANGUAGEFILES",$YANA->language->getContent());
                 $YANA->setVar("SKINFILES",    $YANA->skin->getContent());
                 $YANA->setVar("PLUGINFILES",$PLUGINFILES);
                 $YANA->setVar("PROFILES",$PROFILES);
                 $OPTIONFILES = array();
                 foreach ($PLUGINFILES as $a => $b) {
                   $b = $b['PLUGIN'];
                   if (!empty($b['CONFIG_TEMPLATE']) && isset($b['ACTIVE']) && $b['ACTIVE']) {
                     $OPTIONFILES[count($OPTIONFILES)] = $dir.$b['CONFIG_TEMPLATE'];
                   }
                 }
                 $YANA->setVar("OPTIONFILES",$OPTIONFILES);
        break;

        case "get_config_default":
          $YANA->language->read("admin");
          $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_ADMIN"));
          $YANA->setVar("LANGFILE",     $YANA->language->getContent());
          $YANA->setVar("SKINFILE",     $YANA->skin->getContent());
          $YANA->setVar("WRITEABLE",    $YANA->registry->files['config']->is_writeable());
        break;

        case "get_config_profile":
          $YANA->language->read("admin");
          $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_MOD"));
          $YANA->setVar("LANGFILE",     $YANA->language->getContent());
          $YANA->setVar("SKINFILE",     $YANA->skin->getContent());
          $YANA->setVar("WRITEABLE",    $YANA->registry->files['config']->is_writeable());
        break;

        case "set_config_default":
          $YANA->registry->files['config']->init();
          $YANA->registry->files['config']->insert($this->_genAdminFile($ARGS));
          smartTemplate::clearCache();
          
          if (!$YANA->registry->files['config']->failSafeWrite()) { $YANA->message("error", "500", "index"); };
          $YANA->message("OK", "200", "index");
        break;

        case "set_config_profile":
          $YANA->registry->files['config']->init();
          $YANA->registry->files['config']->insert($this->_genAdminFile($ARGS));
          smartTemplate::clearCache();

          if (!$YANA->registry->files['config']->failSafeWrite()) { $YANA->message("error", "500", "index"); };
          $YANA->message("OK", "200", "index");
        break;

        case "refresh_pluginlist":
                return $YANA->plugins->refreshPluginFile();
        break;

        case "config_create_profile":
                $configFile = $YANA->registry->get("config");
                $REF        = $configFile->get("*");
                $profileDir = $YANA->registry->get("PROFILEDIR");
                $profileDir = $profileDir->getFilename();
                $newProfile = new configfile($profileDir.$ARGS['id'].'.cfg');
                if ($newProfile->exists()) {
                  $YANA->message("error", "allready_exists", "index");
                  return false;
                }
                if (!$newProfile->create()) {
                  $YANA->setVar("FILE", $newProfile->getFilename());
                  $YANA->message("error", "file_not_created", "index");
                  return false;
                }
                if (!$newProfile->set($REF)) {
                  $YANA->message("error", "500", "index");
                  return false;
                }
                if (!$newProfile->write()) {
                  $YANA->setVar("FILE", $newProfile->getFilename());
                  $YANA->message("error", "not_writeable", "index");
                  return false;
                }
                $YANA->message("OK", "200", "index");
                return false;
        break;

        case "config_usermode":
                $configFile = $YANA->registry->get("config");
                $REF        = $configFile->get("*");
                $REF["PROFILE"]["USERMODE"] = !$REF["PROFILE"]["USERMODE"];
                if (!$configFile->insert($REF) || !$configFile->write()) {
                  $YANA->message("error", "500", "index");
                } else {
                  $YANA->message("OK", "200", "index");
                }
                return false;
        break;

        case "about":
                 $YANA->language->read("admin");
                 switch ($ARGS['type']) {
                  
                   case "plugin":
                     $file = $YANA->plugins->getPluginFilename($ARGS['target']);
                     if (is_file($file)) {
                       $YANA->registry->merge("*",getConfigFile($file, true));
                       return true;
                     } else {
                       $YANA->message("error", "404", "index");
                       return false;
                     }
                   break;

                   case "skin":
                     $REF = $YANA->skin->getInfo($ARGS['target']);
                     if (!empty($REF)) {
                       $YANA->setVar("INFO",$REF);
                       return true;
                     } else {
                       $YANA->message("error", "404", "index");
                       return false;
                     }
                   break;

                   case "language":
                     $REF = $YANA->language->getInfo($ARGS['target']);
                     if (!empty($REF)) {
                       $YANA->setVar("INFO",$REF);
                       return true;
                     } else {
                       $YANA->message("error", "404", "index");
                       return false;
                     }
                   break;

                   default:
                   break;

                 }
        break;

        default:
        break;
      } # end switch

    return true;
  }

  /* private Hashtable */ function _genAdminFile(/* Hashtable */ $INPUT) {
      settype($INPUT, "array");
      $INPUT = changeCaseArray($INPUT);

      unset($INPUT['ID']);
      unset($INPUT['ACTION']);
      unset($INPUT['TARGET']);
      unset($INPUT[strtoupper(session_name())]);

      $REF = array();
      foreach ($INPUT as $key=>$element) {
        if (preg_match("/\//", $key))
        {
          $key = preg_replace("/\//", ".", $key);
          eval('$REF["PROFILE"]'.decodeAdress($key).' = "'.strip_tags( (string) $element).'";');
        }
        else
        {
          $REF['PROFILE'][$key] = strip_tags( (string) $element);
        }
      }

      return $REF;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
