<?php


/* public */ class plugin_search extends plugin {

  /* private */ var $search_string = "";
  /* private */ var $cache         = array();

  /* constructor */ function plugin_search($name) {
      settype($name,"string");
      global $YANA;
      $this->name = $name;
  }

  /**
   Default event handler
   
   @param string $event name of the called event in lower-case
   @param array $ARGS array of params passed to the function
   @return boolean
  **/
  function _default(/* String */ $event, /* Hashtable */ $ARGS) {

    # check input data

    settype($event, "string");
    settype($ARGS, "array");

    # do something

    return true;
  }

# BEGIN custom Event-handlers


  /**
   Type: read
   Permission: 0
   Templates:  
   
   @param array $ARGS array of params passed to the function
   @return boolean
  **/

  function search_stats ($ARGS) {
    settype($ARGS, "array");
    global $YANA;

    $statistik = new counter($this->name);
    $zahlen    = $statistik->get();
    if (!empty($zahlen))
    {
      uasort($zahlen, array($this, "_sort"));
      $YANA->setVar("STATS", $zahlen);
    }

    return true;
    
  }


  /**
   Type: read
   Permission: 0
   Templates:  
   
   @param array $ARGS array of params passed to the function
   @return boolean
  **/

  function search_start ($ARGS) {
    # do something
    
    global $YANA;
    settype($ARGS['target'], "string");

    $this->search_string = preg_replace("/[^\s\w\d&;]/i", "", $ARGS['target']);

    if (empty($this->search_string)) return true;

    $statistik = new counter($this->name);
    $temp = explode(" ", strtolower($this->search_string));
    for ($i=0; $i<count($temp); $i++) {
      $statistik->count($this->_encode($temp[$i]),$temp[$i]);
    }

    $trefferliste = $this->_from_cache($this->search_string);
    if (empty($trefferliste))
    $trefferliste = $this->_commit($this->search_string);

    $YANA->setVar("SUBJECT", $this->search_string);
    $target = $YANA->getVar("PROFILE.SEARCH.TARGET"); if (empty($target)) $target = "_self";
    $prefix = $YANA->getVar("PROFILE.SEARCH.PREFIX");

    $script = "";
    for ($i=0; $i<count($trefferliste); $i++)
    if (count($trefferliste[$i])>0 && isset($trefferliste[$i][0]) && $trefferliste[$i][0] != "\n")
    $script .= '  trefferliste[trefferliste.length] = \''.preg_replace("/%/", "#", rawurlencode('<P CLASS="ACOMMENT"><B><A HREF="'.$prefix. htmlentities(preg_replace("/^.\//", "", preg_replace("/^\n/", "", $trefferliste[$i][0]))) .'" TARGET="'.$target.'">'. $trefferliste[$i][1] .'</A></B><BR><SPAN CLASS="BESCHREIBUNG">'. $trefferliste[$i][2] .'</SPAN></P>')).'\';'."\n";

    $YANA->setVar("SCRIPT", $script);

    return true;

  }


# END custom Event-handlers

  function _from_cache($subject) {

    global $YANA;

    $id = $YANA->getVar('ID');
    if (empty($id)) $id = "default";
    $cacheFile = $YANA->getVar('TEMPDIR')."$id.cache";
    $trefferliste = array();
  
    if (file_exists($cacheFile) && is_readable($cacheFile)) {
      $this->cache = file($cacheFile);
    } else {
      return false;
    }

    $this->_cache_id($subject);
    $temp = "";
    for ($i=0;$i<sizeOf($this->cache);$i++) {
      if (preg_match("/^".$subject."=/i", $this->cache[$i])) {
        $temp = preg_replace("/^".$subject."=/", "", $this->cache[$i]);
        break;
      }
    }

    if (!empty($temp)) {
      $temp = explode(";", $temp);
      $this->search_string = rawurldecode($temp[0]);
      for ($i=1;$i<sizeOf($temp);$i++)
      $trefferliste[count($trefferliste)] = explode(',',rawurldecode($temp[$i]));
      return $trefferliste;
    } else {
      return false;
    }
  }

  function _commit($subject) {
    global $YANA;
    $gefunden = 0; $treffer = array(); $trefferliste = array();

    $anfrage   = explode(" ", $subject);

    $keywords  = $YANA->plugins->get($this->name, "KEYWORDS");
    $documents = $YANA->plugins->get($this->name, "DOCUMENTS");

    if (!$keywords->exists() || !$documents->exists())
    $YANA->message("error", "search_failed");

    $keywords->read();
    $KEYS = preg_replace("/\n/", "", $keywords->get());
    $KEYS = explode(", ", $KEYS);

    for ($i = 0; $i < count($anfrage); $i++) {

      $enc_string  = $this->_encode($anfrage[$i]);
      $gefunden    = false;
      $max         = count($KEYS)-1;
      $min         = 0;
      $n           = floor($max /2);
      $prev_n      = array(-1,-1);

      while (!$gefunden && $max != $min) {
        $temp2 = preg_replace("/=.*/i", "", $KEYS[$n]);
        $temp2 = strcasecmp($temp2, $enc_string);
        if ($temp2>0) {
          $max = $n;
        } else if ($temp2<0) {
          $min = $n;
        } else {
          $treffer[$anfrage[$i]]=explode("\"", preg_replace("/.*=/i", "", $KEYS[$n]));
          $whatsRelated = trim(preg_replace("/\|/", " ", preg_replace("/~/", $enc_string, $treffer[$anfrage[$i]][0])));
          $whatsRelated = preg_replace("/\s\s/", " ", $whatsRelated);
          $this->search_string .= '<div style="font-size: 10px;">' . ( $treffer[$anfrage[$i]][0] != "" && $anfrage[$i] != $whatsRelated ? '&nbsp;<a href="javascript:whatsRelated()" target="_self">%LANGUAGE.RELATED%&nbsp;&quot;' .$anfrage[$i]. '&quot;:</a> <span style="font-weight: normal">' . $whatsRelated . '</span></div>' : '' );
          $gefunden = true;
        }

        array_shift($prev_n);
        $prev_n[count($prev_n)] = $n;

        if ($min!=$n) {
            $n = $min + floor( ($max-$min) /2 );
        } else {
            $n = $min + ceil( ($max-$min) /2 );
        }

        if ($prev_n[0]==$n||$prev_n[1]==$n) { $treffer[$anfrage[$i]][0]= ""; break; }

      } # while

    } # for

    if (count($treffer)>0) {
       array_shift($treffer[$anfrage[0]]); // 0. Treffer ist immer leer -> also weg damit!
       $trefferliste=$treffer[$anfrage[0]];
    }

    // BEGINN: UND -Verknpfung
    for ($i=1;$i<count($anfrage);$i++) {
      $myTemp = array();
      for ($j=1;$j<count($treffer[$anfrage[$i]]);$j++)
      if(in_array($treffer[$anfrage[$i]][$j], $trefferliste))
      $myTemp[count($myTemp)] = $treffer[$anfrage[$i]][$j];
      $trefferliste = $myTemp;
    }
    // ENDE: UND -Verknpfung
    
    // BEGINN: Liste der Dokumente laden
    $zeile=0; $buffer = "";

    $file = fopen($documents->getFilename(), "r");
    flock($file,1);
    while (!feof($file)) {
      $temp = fgetc($file);
      if ($temp == ']') {
        if (in_array((int) $zeile, $trefferliste))
        $dokumente[$zeile] = explode(',',$buffer);
        $buffer="";
        $zeile++;
      } else {
        $buffer .= $temp;
      }
    }
    flock($file, 3);
    fclose($file);
    // ENDE: Liste der Dokumente laden
  
    if (count($trefferliste)>=1) {
      // IDs auflsen
      sort($anfrage);
      $this->_to_cache(implode(" ", $anfrage), $trefferliste, $dokumente);
      for ($i=0; $i<count($trefferliste); $i++) {
        if (isset($trefferliste[$i]) && $trefferliste[$i] != "") {
          $trefferliste[$i] = $dokumente[(int) $trefferliste[$i]];
        }
      }
    }

    return $trefferliste;
  }

  function _to_cache($subject, &$value, &$dokumente) {
    global $YANA;

    $id = $YANA->getVar('ID');
    if (empty($id)) $id = "default";
    $cacheFile = $YANA->getVar('TEMPDIR')."$id.cache";
    if (sizeOf($this->cache)>30) { array_pop($this->cache); };
    
    $this->_cache_id($subject);
    $text = $subject.'='.rawurlencode($this->search_string).";";
  
    for ($i=0; $i<count($value); $i++) {
      if (isset($dokumente[$value[$i]])) {
        $text .= rawurlencode(trim(preg_replace("/\s/s", " ", implode(",", $dokumente[$value[$i]])))).";";
      }
    }
  
    $text .= "\n" . implode("", $this->cache);
  
    if (! file_exists($cacheFile)) {
      $datei = fopen($cacheFile, "w+"); flock($datei, 2);
      fwrite($datei, $text);
      flock($datei, 3); fclose($datei);
    } elseif (is_writeable($cacheFile)) {
      $datei = fopen($cacheFile, "w+"); flock($datei, 2);
      fwrite($datei, $text);
      flock($datei, 3); fclose($datei);
    } else {
      return false;
    }
  
    return true;

  }

  function _cache_id(&$subject) {
    settype($subject, "string");
    $temp = explode(" ", $subject);
    for ($i=0;$i<sizeOf($temp);$i++)
    $temp[$i] = $this->_encode($temp[$i]);
    sort($temp);
    $subject = implode(" ", $temp);
  }

  function _sort($A, $B) {
    if      ($A['COUNT'] < $B['COUNT']) return +1;
    else if ($A['COUNT'] > $B['COUNT']) return -1;
    else
    {
      if      ($A['INFO'] < $B['INFO']) return -1;
      else if ($A['INFO'] > $B['INFO']) return +1;
      else                              return 0;
    }
  }

  function _encode($inputString) {
  
    $inputString = strtolower($inputString);
  
    $inputString = preg_replace("//", 'a', $inputString);
    $inputString = preg_replace("//", 'a', $inputString);
    $inputString = preg_replace("/\&Auml;/i", 'a', $inputString);
    $inputString = preg_replace("/\&auml;/i", 'a', $inputString);
    $inputString = preg_replace("//", 'u', $inputString);
    $inputString = preg_replace("//", 'u', $inputString);
    $inputString = preg_replace("/\&Uuml;/i", 'u', $inputString);
    $inputString = preg_replace("/\&uuml;/i", 'u', $inputString);
    $inputString = preg_replace("//", 'o', $inputString);
    $inputString = preg_replace("//", 'o', $inputString);
    $inputString = preg_replace("/\&Ouml;/i", 'o', $inputString);
    $inputString = preg_replace("/\&ouml;/i", 'o', $inputString);
    $inputString = preg_replace("//i", 'ss', $inputString);
    $inputString = preg_replace("/\&szlig;/i", 'ss', $inputString);
    $inputString = preg_replace("/\&nbsp;/i", ' ', $inputString);
    $inputString = preg_replace("/[^\w_\s]/Ui", '', $inputString);
  
    if ($inputString=="und" || $inputString=="hin" || $inputString=="her" || $inputString=="you" ||$inputString=="dort" ||$inputString=="hier" ||$inputString=="bis" ||$inputString=="oder" || $inputString=="aber" || $inputString=="et" || $inputString=="cetera" ||$inputString=="etc" || $inputString=="usw" || $inputString=="bzw" || $inputString=="beziehungsw" || $inputString=="beziehungsweise" || $inputString=="weiterer" || $inputString=="weiter" || $inputString=="weitere" || $inputString=="weiteren" || $inputString=="wer" || $inputString=="wie" || $inputString=="was" || $inputString=="zum" || $inputString=="sich" || $inputString=="mit" || $inputString=="und" || $inputString=="dem" || $inputString=="denen" || $inputString=="deren" || $inputString=="dessen" || $inputString=="von" || $inputString=="der" || $inputString=="die" || $inputString=="das" || $inputString=="ich" || $inputString=="sie" || $inputString=="wir" || $inputString=="ihr" || $inputString=="ihnen" || $inputString=="ihren" || $inputString=="deinen" || $inputString=="den" || $inputString=="des" || $inputString=="ihn" || $inputString=="ihm") {
        $inputString = "";
    } else {
  
        if (preg_match("/^selbst/i", $inputString) && strlen($inputString) > 6) { $inputString = substr($inputString, 6, strlen($inputString));
        } else if (preg_match("/^gross/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^durch/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^gegen/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^haupt/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^neben/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^unter/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^nacht/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^klein/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
        } else if (preg_match("/^orts/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
        } else if (preg_match("/^voll/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
        } else if (preg_match("/^fern/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
        } else if (preg_match("/^ober/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
        } else if (preg_match("/^nach/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
        } else if (preg_match("/^uber/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString)); };
  
        if (preg_match("/lichkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-10);
        } else if (preg_match("/igkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-8);
        } else if (preg_match("/igkeit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/lichkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-10);
        } else if (preg_match("/lichkeit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-8);
        } else if (preg_match("/lichen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/lichem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/ungen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-5);
        } else if (preg_match("/ungem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-5);
        } else if (preg_match("/iges$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/igen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/igem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/keiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/keit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
        } else if (preg_match("/lichen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/lichem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/lich$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
        } else if (preg_match("/heiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
        } else if (preg_match("/innen$/Ui", $inputString) && $inputString != "innen") { $inputString = substr($inputString, 0, strlen($inputString)-5);
        } else if (preg_match("/enden$/Ui", $inputString) && $inputString != "enden") { $inputString = substr($inputString, 0, strlen($inputString)-5);
        } else if (preg_match("/end$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/ende$/Ui", $inputString) && $inputString != "ende") { $inputString = substr($inputString, 0, strlen($inputString)-4);
        } else if (preg_match("/heit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
        } else if (preg_match("/ung$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/tum$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/ten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/tem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/ers$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/ern$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
        } else if (preg_match("/em$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/en$/Ui", $inputString)) {$inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/er$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/es$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/te$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/ts$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
        } else if (preg_match("/t$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1);
        } else if (preg_match("/e$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1);
        } else if (preg_match("/s$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1); };
        $inputString = preg_replace("/ /", "", $inputString);
    };
  
    return trim($inputString);
  
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!

?>