<?php

/* public */ class plugin_user_admin extends plugin {

  /* private user_admin */ var $file;

  /* constructor */ function plugin_user_admin($name) {
    settype($name,"string");
    $this->name = $name;
    global $YANA;
    $this->file = new user_admin($YANA->plugins->get($this->name,"USER_DB"));
    $dir = $YANA->getVar("PROFILE.SMILEYDIR");
    if (is_dir($dir)) loadSmilies($dir);
  }

  /* public void */ function _default(/* String */ $event, /* Hashtable */ $ARGS) {
     settype($event, "string");
     settype($ARGS, "array");
     $event = strtolower($event);

     if (!$this->file->isEmpty()) {

       global $YANA;
       $YANA->setVar("ID",((!empty($ARGS['id'])) ? $ARGS['id'] : ""));
       $YANA->setVar("FORM_PARAMS", '
      <input type="hidden" name="target" value="'.YANA_UNI_DELIMITER.'TARGET'.YANA_UNI_DELIMITER.'">' .( (session_id()) ? '
      <input type="hidden" name="'.@session_name().'" value="'.@session_id().'">' : '' ). '
      <input type="hidden" name="id" value="'.YANA_UNI_DELIMITER.'ID'.YANA_UNI_DELIMITER.'">');

       switch ($event) {

         case "get_user_list":
                return $this->file->get_user_configuration();
         break;

         case "get_user_edit":
                $YANA->setVar("TARGET",$ARGS['target']);
                return $this->file->get_user_edit($ARGS['target']);
         break;

         case "set_user_edit":
                $ARGS['active'] = !empty($ARGS['active']);
                return $this->file->set_user_edit($ARGS['target'],$ARGS);
         break;

         case "get_user_delete":
                $YANA->setVar("TARGET", $ARGS['target']);
                return $this->file->get_user_delete($ARGS['target']);
         break;

         case "set_user_delete":
                return $this->file->set_user_delete($ARGS['target']);
         break;

         case "get_user_new":
                $YANA->setVar("TARGET",$ARGS['target']);
                return $this->file->get_user_new($ARGS['target']);
         break;

         case "set_user_new":
                if ($this->file->set_user_new($ARGS['target'],$ARGS))
                {
                  $YANA->message("OK", "200", "index");
                  return false;
                } else {
                  $YANA->message("error", "500", "index");
                  return false;
                }
         break;

         case "set_user_pwd":
                $YANA->language->read("user");
                if ($this->file->set_user_pwd($ARGS['target']))
                {
                  $YANA->message("OK", "200", "index");
                  return false;
                } else {
                  $YANA->message("error", "500", "index");
                  return false;
                }
         break;

         /* <FORMULAR> Mail-Authentifizierung */
         case "get_user_mail":
               $YANA->setVar("TARGET",(!empty($ARGS['target'])) ? $ARGS['target'] : '');
               if (!$YANA->getVar("PROFILE.USER.ALLOW_CREATE"))
               {
                 $YANA->message("error", "ungueltige_eingabe", "");
                 return false;
               }

               $YANA->setVar("ACTION_PARAMS", '<input type="hidden" name="action" value="SET_USER_MAIL">');
         break;

         /* <SESSION-ERZEUGEN> Mail-Authentifizierung */
         case "set_user_mail":
               if (!$YANA->getVar("PROFILE.USER.ALLOW_CREATE"))
               {
                 $YANA->message("error", "ungueltige_eingabe", "");
                 return false;
               }

               $file    = false;

               if ($this->file->userExists($ARGS['username'])) {

                 $YANA->message("alert", "user_already_exists", "get_user_mail");
                 return false;

               } else if (!preg_match("/^\S+\@\S+\.\w{2,}$/", $ARGS['mail']) || !preg_match("/^[\w_-]+$/",$ARGS['username'])) {
    
                 // Mailadresse ist ungltig oder leerer Benutzername
                 $YANA->message("alert", "ungueltige_eingabe", "get_user_mail");
                 return false;
    
               } else {
    
                 $file = $YANA->plugins->get($this->name,"TEMPDATA");
                 $file->init();
    
                 if (!$file->exists() && !$file->create())
                 {
    
                   $YANA->setVar("FILE", $file->getFilename());
                   $YANA->message("error", "file_not_created", "");
                   return false;

                 }
                 else
                 {
                   
                   $file->insert($ARGS['mail'], $ARGS['username']);

                   $YANA->setVar('WEBSITE_URL', $YANA->getVar("REFERER"));
                   $YANA->setVar('KEY', $file->getRecentKey());
                   $YANA->setVar('MAIL', $ARGS['mail']);
                   if (empty($REF['WEBSITE_URL'])) $REF['WEBSITE_URL'] = " ";
                   user_admin::send_mail($ARGS['mail'],$YANA->skin->getFile("USER_CONFIRM_MAIL"));

                   if (!$file->write())
                   {
                     $YANA->setVar("FILE", $file->getFilename());
                     $YANA->message("error", "not_writeable", "");
                     return false;
                   }
                   else
                   {
                     $YANA->message("OK", 200, "");
                     return false;
                   }
    
                 }
    
               }
         break;

         case "user_authentification":
               if (!$YANA->getVar("PROFILE.USER.ALLOW_CREATE"))
               {
                 $YANA->message("error", "ungueltige_eingabe", "");
                 return false;
               }

               $REF = array();

               $file = $YANA->plugins->get($this->name,"TEMPDATA");
               if (!$file->keyExists($ARGS['target']) || !$REF = $file->get($ARGS['target']))
               {

                 $YANA->message("error", "ungueltige_eingabe", "");
                 return false;

               }
               else
               {
                 $REF1 = $ARGS;
                 $REF1['MAIL'] = $REF['MAIL'];
                 if ($this->file->user_authentification($REF['USERNAME'],$REF1))
                 {
                   $YANA->message("alert", "first_login", "");
                   return false;
                 }
                 else
                 {
                   $YANA->message("error", "500", "");
                   return false;
                 }

               }
         break;

         case "view_profile":
           return $this->file->get_user($ARGS['target']);
         break;

         case "get_profile_edit":
           $YANA->setVar("TARGET",$ARGS['target']);
           return $this->file->get_user($ARGS['target'], true);
         break;

         case "set_profile_edit":
           return $this->file->set_profile_edit($ARGS);
         break;

         default:
                $YANA->language->read("user");
                $USERLIST   = $this->file->getUserList();
                $YANA->setVar("USERLIST",$USERLIST);
         break;

       } # end switch
     }
     return true;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
